<?php

defined('MOODLE_INTERNAL') || die();

// http://phpqrcode.sourceforge.net/
include "phpqrcode/qrlib.php";

class block_qruri extends block_base {
   
  function init() {
    $this->title = 'QR URI';
  }

  function get_content() {
    if ($this->content !== NULL) {
      return $this->content;
    }

    // Get current URI
    // http://suin.asia/2009/09/06/how_to_get_current_url_by_php
    if ( isset($_SERVER['HTTPS']) and $_SERVER['HTTPS'] == 'on' ){  
      $protocol = 'https://';  
    }else{  
      $protocol = 'http://';  
    }  
    $uri  = $protocol.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];  

    if (empty($this->config->qrsize)){
      $qrsize= 4;
    }else{
      $qrsize= $this->config->qrsize;
    }

    // QR code for current URI
    $this->content->text.= $this->mk_qrcode($uri,$qrsize);
    $this->content->text.= '<p style="font-size:x-small">'.$uri.'</p>';

    // QR code for string at config
    if (!empty($this->config->qrstring)){
      $this->content->text.= $this->mk_qrcode($this->config->qrstring,$qrsize);
      $this->content->text.= '<p style="font-size:x-small">'.$this->config->qrstring.'</p>';
    }

    return $this->content;
  }

  function mk_qrcode($string,$qrsize) {
    $ret= '';
    $size= $qrsize."px"; 

    $qr= new QRencode();
    $frame = $qr->encode($string);
    foreach ($frame as &$frameLine) {
      $frameLine = join('<td class="qrwhite"><br/></td>', explode('0', $frameLine));
      $frameLine = join('<td class="qrblack"><br/></td>', explode('1', $frameLine));
    }
    $ret.= "<style>.qrwhite{font-size:$size; line-height:$size; width:$size; height:$size; margin:0px; padding:0px; background-color:white;} .qrblack{font-size:$size; line-height:$size; width:$size; height:$size; margin:0px; padding:0px; background-color:black;}</style>\n";
    $ret.= '<table><tr>';
    $ret.= join("</tr>", $frame);
    $ret.= '</table>';
    return $ret;
  }
}
